searchNodes=[{"doc":"Models a list of filters to apply to a collection (list) of data items","ref":"Filters.html","title":"Filters","type":"module"},{"doc":"Add or update an existing filter in the list. Two filters cannot have the same :filter_type and :key .","ref":"Filters.html#add_update/2","title":"Filters.add_update/2","type":"function"},{"doc":"Filter the provided data with a list of filters Examples Text filters iex&gt; filters = Filters . new ( ) ...&gt; |&gt; Filters . add_update ( Filters.Filter . new ( :text , :is , &quot;liv&quot; ) ) iex&gt; Filters . filter ( [ ...&gt; %{ type : &quot;human&quot; , is : &quot;Philip J. Fry&quot; } , ...&gt; %{ type : &quot;robot&quot; , is : &quot;Bender Rodriguez&quot; } , ...&gt; %{ type : &quot;human&quot; , is : &quot;Turanga Leila&quot; } , ...&gt; %{ type : &quot;robot&quot; , is : &quot;R. Daneel Oliva&quot; } , ...&gt; %{ type : &quot;drink&quot; , is : &quot;Martini with an olive&quot; } , ...&gt; %{ type : &quot;actions&quot; , are : &quot;eat, live, think&quot; } ...&gt; ] , filters ) [ %{ type : &quot;drink&quot; , is : &quot;Martini with an olive&quot; } , %{ type : &quot;robot&quot; , is : &quot;R. Daneel Oliva&quot; } ] Enum filters iex&gt; filters = Filters . new ( ) ...&gt; |&gt; Filters . add_update ( Filters.Filter . new ( :enum , :type , &quot;human&quot; ) ) iex&gt; Filters . filter ( [ ...&gt; %{ type : &quot;human&quot; , is : &quot;Philip J. Fry&quot; } , ...&gt; %{ type : &quot;robot&quot; , is : &quot;Bender Rodriguez&quot; } , ...&gt; %{ type : &quot;human&quot; , is : &quot;Turanga Leila&quot; } , ...&gt; %{ type : &quot;humanoid&quot; , is : &quot;R. Daneel Oliva&quot; } ...&gt; ] , filters ) [ %{ type : &quot;human&quot; , is : &quot;Turanga Leila&quot; } , %{ type : &quot;human&quot; , is : &quot;Philip J. Fry&quot; } ] Date filters iex&gt; filters = Filters . new ( ) ...&gt; |&gt; Filters . add_update ( Filters.Filter . new ( :date_from , :birthday , &quot;2042-11-12&quot; ) ) ...&gt; |&gt; Filters . add_update ( Filters.Filter . new ( :date_to , :birthday , &quot;2042-12-12&quot; ) ) iex&gt; Filters . filter ( [ ...&gt; %{ birthday : &quot;2042-12-11&quot; , of : &quot;Bender Rodriguez&quot; } , ...&gt; %{ birthday : &quot;2042-11-11&quot; , of : &quot;Philip J. Fry&quot; } , ...&gt; %{ birthday : &quot;2042-11-12&quot; , of : &quot;Turanga Leila&quot; } , ...&gt; %{ birthday : &quot;2042-11-13&quot; , of : &quot;Hubert Farnsworth&quot; } , ...&gt; %{ birthday : &quot;2042-12-12&quot; , of : &quot;Amy Wong&quot; } , ...&gt; %{ birthday : &quot;2042-12-13&quot; , of : &quot;Doctor Zoidberg&quot; } , ...&gt; %{ birthday : &quot;2042-12-12&quot; , of : &quot;Hermes Conrad&quot; } ...&gt; ] , filters ) [ %{ birthday : &quot;2042-12-12&quot; , of : &quot;Hermes Conrad&quot; } , %{ birthday : &quot;2042-12-12&quot; , of : &quot;Amy Wong&quot; } , %{ birthday : &quot;2042-11-13&quot; , of : &quot;Hubert Farnsworth&quot; } , %{ birthday : &quot;2042-11-12&quot; , of : &quot;Turanga Leila&quot; } , %{ birthday : &quot;2042-12-11&quot; , of : &quot;Bender Rodriguez&quot; } ] Multiple filters (and logic) iex&gt; filters = Filters . new ( ) ...&gt; |&gt; Filters . add_update ( Filters.Filter . new ( :enum , :type , &quot;human&quot; ) ) ...&gt; |&gt; Filters . add_update ( Filters.Filter . new ( :text , :is , &quot;Leila&quot; ) ) iex&gt; Filters . filter ( [ ...&gt; %{ hello : &quot;world&quot; , type : &quot;human&quot; , is : &quot;Philip J. Fry&quot; } , ...&gt; %{ hello : &quot;world&quot; , type : &quot;robot&quot; , is : &quot;Bender Rodriguez&quot; } , ...&gt; %{ hell : &quot;world&quot; , type : &quot;human&quot; , is : &quot;Turanga Leila&quot; } , ...&gt; %{ hello : &quot;word&quot; , type : &quot;humanoid&quot; , is : &quot;R. Daneel Oliva&quot; } ...&gt; ] , filters ) [ %{ hell : &quot;world&quot; , type : &quot;human&quot; , is : &quot;Turanga Leila&quot; } ] Multiple filters (or logic) iex&gt; filters = Filters . new ( :or ) ...&gt; |&gt; Filters . add_update ( Filters.Filter . new ( :enum , :type , &quot;human&quot; ) ) ...&gt; |&gt; Filters . add_update ( Filters.Filter . new ( :text , :is , &quot;Bender&quot; ) ) iex&gt; Filters . filter ( [ ...&gt; %{ hello : &quot;world&quot; , type : &quot;human&quot; , is : &quot;Philip J. Fry&quot; } , ...&gt; %{ hello : &quot;world&quot; , type : &quot;robot&quot; , is : &quot;Bender Rodriguez&quot; } , ...&gt; %{ hell : &quot;world&quot; , type : &quot;human&quot; , is : &quot;Turanga Leila&quot; } , ...&gt; %{ hello : &quot;word&quot; , type : &quot;humanoid&quot; , is : &quot;R. Daneel Oliva&quot; } ...&gt; ] , filters ) [ %{ hell : &quot;world&quot; , type : &quot;human&quot; , is : &quot;Turanga Leila&quot; } , %{ hello : &quot;world&quot; , type : &quot;robot&quot; , is : &quot;Bender Rodriguez&quot; } , %{ hello : &quot;world&quot; , type : &quot;human&quot; , is : &quot;Philip J. Fry&quot; } ]","ref":"Filters.html#filter/2","title":"Filters.filter/2","type":"function"},{"doc":"Serialize a list of filters into URL query parameters Example iex&gt; % Filters { ...&gt; filters : [ ...&gt; % Filters.Filter { filter_type : :text , key : :genre , value : &quot;industrial metal&quot; } , ...&gt; % Filters.Filter { filter_type : :text , key : :artist , value : &quot;Dance With&quot; } ...&gt; ] , ...&gt; logic : :and ...&gt; } |&gt; Filters . filters_to_query ( ) |&gt; URI . decode ( ) &quot;logic=and&amp;genre=text|industrial metal&amp;artist=text|Dance With&quot;","ref":"Filters.html#filters_to_query/2","title":"Filters.filters_to_query/2","type":"function"},{"doc":"Return a filter matching by :filter_type and :key","ref":"Filters.html#get/2","title":"Filters.get/2","type":"function"},{"doc":"Create a new set of filters","ref":"Filters.html#new/2","title":"Filters.new/2","type":"function"},{"doc":"Return a tuple with the found filter and the remaining ones Useful to drop a filter or to update it","ref":"Filters.html#pop/2","title":"Filters.pop/2","type":"function"},{"doc":"Deserialize URL query parameters into a list of filters Example iex&gt; &quot;logic=and&amp;genre=text%7Cindustrial%20metal&amp;artist=text%7CDance%20With&quot; ...&gt; |&gt; Filters . query_to_filters ( keys : :atoms ) % Filters { filters : [ % Filters.Filter { filter_type : :text , key : :genre , value : &quot;industrial metal&quot; } , % Filters.Filter { filter_type : :text , key : :artist , value : &quot;Dance With&quot; } ] , logic : :and }","ref":"Filters.html#query_to_filters/2","title":"Filters.query_to_filters/2","type":"function"},{"doc":"","ref":"Filters.html#t:filters_data/0","title":"Filters.filters_data/0","type":"type"},{"doc":"","ref":"Filters.html#t:logic/0","title":"Filters.logic/0","type":"type"},{"doc":"","ref":"Filters.html#t:t/0","title":"Filters.t/0","type":"type"},{"doc":"Struct used to recevive responses from HTTP servers","ref":"Filters.Filter.html","title":"Filters.Filter","type":"module"},{"doc":"","ref":"Filters.Filter.html#equals/2","title":"Filters.Filter.equals/2","type":"function"},{"doc":"","ref":"Filters.Filter.html#match/2","title":"Filters.Filter.match/2","type":"function"},{"doc":"","ref":"Filters.Filter.html#new/3","title":"Filters.Filter.new/3","type":"function"},{"doc":"","ref":"Filters.Filter.html#normalize/1","title":"Filters.Filter.normalize/1","type":"function"},{"doc":"","ref":"Filters.Filter.html#tmatch/2","title":"Filters.Filter.tmatch/2","type":"function"},{"doc":"","ref":"Filters.Filter.html#validate/1","title":"Filters.Filter.validate/1","type":"function"},{"doc":"Use this to filter out data past the date expressed in the filter value.","ref":"Filters.Filter.html#t:date_from/0","title":"Filters.Filter.date_from/0","type":"type"},{"doc":"Use this to filter out data exceeding the date expressed in the filter value.","ref":"Filters.Filter.html#t:date_to/0","title":"Filters.Filter.date_to/0","type":"type"},{"doc":"Expresses a date formatted as &quot;yyyy-mm-dd&quot;","ref":"Filters.Filter.html#t:date_value/0","title":"Filters.Filter.date_value/0","type":"type"},{"doc":"Use this for exact matching across a list of well known (and limited amount of) items.","ref":"Filters.Filter.html#t:enum/0","title":"Filters.Filter.enum/0","type":"type"},{"doc":"","ref":"Filters.Filter.html#t:filter_type/0","title":"Filters.Filter.filter_type/0","type":"type"},{"doc":"","ref":"Filters.Filter.html#t:key/0","title":"Filters.Filter.key/0","type":"type"},{"doc":"","ref":"Filters.Filter.html#t:t/0","title":"Filters.Filter.t/0","type":"type"},{"doc":"Matches any sub token at any point in the string value, E.g. &quot;The white rabbit&quot; data matches &quot;te rab&quot; text filter value","ref":"Filters.Filter.html#t:text/0","title":"Filters.Filter.text/0","type":"type"},{"doc":"","ref":"Filters.Filter.html#t:value_type/0","title":"Filters.Filter.value_type/0","type":"type"}]